
{-
Decidable : Prop -> Prop
Decidable P = P \/ Not P

decideEq : (n,m:Nat) -> Decidable (n == m)
decideEq zero zero = inl refl
decideEq (suc n) (suc m) with decideEq n m =>
  (suc n) (suc m) (inl eq) = inl (cong suc eq)
  (suc n) (suc m) (inr neq) = inr (\h -> neq $ sucInj h)
decideEq  zero   (suc m) = inr zeroNotSuc
decideEq (suc n)  zero	 = inr sucNotZero

lem (n,m : Nat) : n < m -> suc n < m \/ suc n == m
lem {zero}  {suc zero} _    = inr refl
lem {zero}  {suc (suc m)} _ = inl tt
lem {suc n} {suc m} h = fol-plugin(lem {n} {m} h)

DivMod : Nat -> Nat -> Prop
DivMod n m = Exist $ \q -> Exist $ \r -> n == q * m + r /\ r < m

divmod : (n,m:Nat) -> 0 < m -> DivMod n m
divmod  zero   m mnz = witness 0 $ witness 0 $ andI refl mnz
divmod (suc n) m mnz = step (divmod n m mnz)
  where
    step : DivMod n m -> DivMod (suc n) m
    step (witness q (witness r _)) with decideEq m (suc r) =>
      (witness q (witness r (andI "n=q*m+r" "r<m")))
	(inl "suc r=m") =
	  witness (suc q) $
	  witness zero $
	  andI fol-plugin("n=q*m+r","suc r=m", (+))
	       mnz
      (witness q (witness r (andI "n=q*m+r" "r<m")))
	(inr "suc r!=m") =
	  witness q $
	  witness (suc r) $
	  andI fol-plugin("n=q*m+r")
	       fol-plugin(lem "r<m","suc r!=m")

mod : (n,m:Nat) -> 0 < m -> Nat
mod n m mnz with divmod n m mnz =>
  n m mnz (witness _ (witness r _)) = r

div : (n,m:Nat) -> 0 < m -> Nat
div n m mnz with divmod n m mnz =>
  n m mnz (witness q _) = q

-}
