{-# OPTIONS -cpp #-}

module IO.Invoke (invoke, invoke_) where

import System.Cmd

import IO.Temp

invoke' :: String -> [String] -> Maybe String -> IO (String, String)
invoke' cmd args inp =
    do	stdin <- case inp of
		    Nothing -> return Nothing
		    Just i  -> do   stdin <- mkTempFile ".input"
				    writeFile stdin i
				    return $ Just stdin
	stdout <- mkTempFile ".output"
	stderr <- mkTempFile ".error"
	system $ unwords $ (cmd : args) ++ mkIn stdin ++ mkOut stdout ++ mkErr stderr
	out <- readFile stdout
	err <- readFile stderr
	return (out, err)
    where
	mkOut x = [">",  x]
	mkErr x = ["2>", x]
	mkIn mx = maybe [] (\x -> ["<", x]) mx

invoke :: FilePath -> [String] -> String -> IO (String, String)
invoke cmd args inp = invoke' cmd args (Just inp)

invoke_ :: FilePath -> [String] -> IO (String, String)
invoke_ cmd args = invoke' cmd args Nothing

