
-- # import id
-- # import bool

data Nat : Set where
  zero : Nat
  suc  : Nat -> Nat

infixl 10 +
infixl 12 *

iszero : Nat -> Bool
iszero 0	= true
iszero (suc n)	= false

(+) : Nat -> Nat -> Nat
0     + m = m
suc n + m = suc (n + m)

(*) : Nat -> Nat -> Nat
n * 0	   = 0
n * suc m  = m + n * m

plus0 : (n : Nat) -> n + 0 == n
plus0 0	      = refl
plus0 (suc n) = cong suc (plus0 n)

plusS : (n, m : Nat) -> n + suc m == suc (n + m)
plusS 0 m	= refl
plusS (suc n) m	= cong suc (plusS n m)

rewrite plus0; plusS

infix 5 <=

data (<=) : Nat -> Nat -> Set where
  le0 (n : Nat)	    : 0 <= n
  leS (n, m : Nat)  : n <= m -> suc n <= suc m

leSuc (n, m : Nat) : n <= m -> n <= suc m
leSuc le0     = le0
leSuc (leS p) = leS (leSuc p)

